import java.awt.Graphics;
import java.util.*;
import java.text.DateFormat;

public class Clock extends java.applet.Applet implements Runnable {
    private Thread clockThread = null;
    
	// Allo start dell'applet, si genera un nuovo thread, se questo non e' gia' presente
	public void start() {
        if (clockThread == null) {
            clockThread = new Thread(this, "Clock");
            clockThread.start();
        }
    }

	// Ciclo di vita del thread creato
    public void run() {
	Thread myThread = Thread.currentThread();
        while (clockThread == myThread) {
            repaint();
            try {
                Thread.sleep(1000);
            } catch (InterruptedException e){ }
        }
    }

	// Visualizzazione dell'orologio
	public void paint(Graphics g) {
        Calendar cal = Calendar.getInstance();
        Date date = cal.getTime();
        DateFormat dateFormatter = DateFormat.getTimeInstance();
        g.drawString(dateFormatter.format(date), 5, 10);
    }
    
	// Stop dell'applet, elimino il riferimento all'oggetto thread (garbage collection!)
	public void stop() {
        clockThread = null;
    }
}
